package edu.washington.cs.money;

public class BankAccount {

	private String m_name;
	private int m_account_id;
	private Money m_balance;
	private USDollarsManipulator usd;

	public BankAccount(String name, int id) {

		usd = (USDollarsManipulator)Bank.getCurrencyManipulator();
		
		m_name = name;
		m_account_id = id;
		m_balance = new Money(0.0);	
	}

	public Money makeDeposit(Money amount) {
		double dep = amount.getAmount();
		double bal = m_balance.getAmount();
		bal = usd.truncateToTwoCents(bal);
		dep = usd.truncateToTwoCents(dep);
		double new_bal = bal + dep;
		new_bal = usd.truncateToTwoCents(new_bal);
		Money new_balance = new Money(new_bal);
		m_balance = new_balance;
		return new_balance;
	}
	
	public Money getBalance() {
		return m_balance;
	}

	public Money makeWithdrawal(Money amount) throws BankException {
		double amt = amount.getAmount();
		double bal = m_balance.getAmount();
		if (amt > bal) {
			throw new BankException("insufficient funds");
		}
		amt = usd.truncateToTwoCents(amt);
		bal = usd.truncateToTwoCents(bal);
		double new_bal = bal - amt;
		new_bal = usd.truncateToTwoCents(new_bal);
		Money new_balance = new Money(new_bal);
		m_balance = new_balance;
		return new_balance;
	}
	
}
